<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Views/ModuleIndex.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Views/ModuleIndex.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Views/ModuleIndex.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Parameter</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.View <span class="py-keyword">import</span> View</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line13"></a><span class="lineno"> 13</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleIndex/ModuleIndex.html">ModuleIndex</a>(View):</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">   <span class="py-string">&quot;&quot;&quot;A module for indexing ASG.Modules. Each module gets its own view with a</span></span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-string">   list of nested scope declarations with documentation. It is intended to go in</span></span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-string">   the left frame...&quot;&quot;&quot;</span></span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleIndex/ModuleIndex.html#register">register</a>(self, frame):</span>
<a id="line20"></a><span class="lineno"> 20</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">      super(ModuleIndex, self).register(frame)</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">      self.__filename = self.directory_layout.module_index(self.processor.root.name)</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">      self.__title = <span class="py-string">'Global %s Index'</span>%self.processor.root.type.capitalize()</span>
<a id="line24"></a><span class="lineno"> 24</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleIndex/ModuleIndex.html#filename">filename</a>(self):</span>
<a id="line26"></a><span class="lineno"> 26</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">      <span class="py-keyword">return</span> self.__filename</span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleIndex/ModuleIndex.html#title">title</a>(self):</span>
<a id="line30"></a><span class="lineno"> 30</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">      <span class="py-keyword">return</span> self.__title</span>
<a id="line32"></a><span class="lineno"> 32</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleIndex/ModuleIndex.html#process">process</a>(self):</span>
<a id="line34"></a><span class="lineno"> 34</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">      self.module_queue = [self.processor.root]</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">      <span class="py-keyword">while</span> self.module_queue:</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">         m = self.module_queue.pop(0)</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">         self.process_module_index(m)</span>
<a id="line39"></a><span class="lineno"> 39</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleIndex/ModuleIndex.html#make_view_heading">make_view_heading</a>(self, module):</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Creates a HTML fragment which becomes the name at the top of the</span></span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line"><span class="py-string">      index view. This may be overridden, but the default is (now) to make a</span></span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line"><span class="py-string">      linked fully scoped name, where each scope has a link to the relevant</span></span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line"><span class="py-string">      index.&quot;&quot;&quot;</span></span>
<a id="line45"></a><span class="lineno"> 45</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">      name = module.name</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">      <span class="py-keyword">if</span> <span class="py-keyword">not</span> name: <span class="py-keyword">return</span> <span class="py-string">'Global Index'</span></span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">      links = []</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">      <span class="py-keyword">for</span> depth <span class="py-keyword">in</span> range(0, len(name)):</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">         url = self.directory_layout.module_index(name[:depth+1])</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">         label = escape(name[depth])</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">         links.append(href(rel(self.__filename, url), label))</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">      <span class="py-keyword">return</span> element(<span class="py-string">'b'</span>, name.sep.join(links) + <span class="py-string">' Index'</span>)</span>
<a id="line54"></a><span class="lineno"> 54</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleIndex/ModuleIndex.html#process_module_index">process_module_index</a>(self, module):</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">      <span class="py-string">&quot;Index one module&quot;</span></span>
<a id="line57"></a><span class="lineno"> 57</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">      sorter = self.processor.sorter.clone(module.declarations)</span>
<a id="line59"></a><span class="lineno"> 59</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">      self.__filename = self.directory_layout.module_index(module.name)</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">      self.__title = str(module.name) <span class="py-keyword">or</span> <span class="py-string">'Global Module'</span></span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">      self.__title = self.__title + <span class="py-string">' Index'</span></span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">      <span class="py-comment"># Create file</span></span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">      self.start_file()</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">      <span class="py-comment">#target = rel(self.__filename, self.directory_layout.scope(module.name))</span></span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">      <span class="py-comment">#link = href(target, self.__title, target='content')</span></span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">      self.write(self.make_view_heading(module))</span>
<a id="line68"></a><span class="lineno"> 68</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">      toc = self.processor.toc</span>
<a id="line70"></a><span class="lineno"> 70</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">      <span class="py-comment"># Make script to switch main frame upon load</span></span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">      load_script = <span class="py-string">'&lt;!--\n'</span></span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">      <span class="py-keyword">if</span> toc[module.name]:</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">         target = rel(self.__filename, toc[module.name].link)</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">         load_script = load_script + <span class="py-string">'window.parent.frames[&quot;content&quot;].location=&quot;%s&quot;;\n'</span>%target</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">      load_script = load_script + <span class="py-string">'function go(index,detail) {\n'</span><span class="py-string">'window.parent.frames[&quot;index&quot;].location=index;\n'</span><span class="py-string">'window.parent.frames[&quot;detail&quot;].location=detail;\n'</span><span class="py-string">'return false;}\n--&gt;'</span></span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">      self.write(element(<span class="py-string">'script'</span>, load_script, type=<span class="py-string">'text/javascript'</span>))</span>
<a id="line78"></a><span class="lineno"> 78</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">      <span class="py-comment"># Loop throught all the types of children</span></span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">      <span class="py-keyword">for</span> section <span class="py-keyword">in</span> sorter:</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">         heading = <span class="py-string">'&lt;br/&gt;\n'</span>+element(<span class="py-string">'i'</span>, escape(section))+<span class="py-string">'&lt;br/&gt;\n'</span></span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">         <span class="py-comment"># Get a list of children of this type</span></span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">         <span class="py-keyword">for</span> child <span class="py-keyword">in</span> sorter[section]:</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">            <span class="py-comment"># Print out summary for the child</span></span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">            <span class="py-keyword">if</span> <span class="py-keyword">not</span> isinstance(child, ASG.Scope):</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">               <span class="py-keyword">continue</span></span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">            <span class="py-keyword">if</span> heading:</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">               self.write(heading)</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">               heading = None</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">            label = str(module.name.prune(child.name))</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">            label = escape(label)</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">            label = replace_spaces(label)</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">            <span class="py-keyword">if</span> isinstance(child, ASG.Module):</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">               index_url = rel(self.__filename,</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">                               self.directory_layout.module_index(child.name))</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">               self.write(href(index_url, label, target=<span class="py-string">'detail'</span>))</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">               entry = toc[child.name]</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">               <span class="py-keyword">if</span> entry:</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">                  url = rel(self.__filename, entry.link)</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">                  self.write(href(url, label, target=<span class="py-string">'content'</span>))</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">               <span class="py-keyword">else</span>:</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">                  self.write(label)</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">            self.write(<span class="py-string">'&lt;br/&gt;\n'</span>)</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">      self.end_file()</span>
<a id="line106"></a><span class="lineno">106</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">      children = [c <span class="py-keyword">for</span> c <span class="py-keyword">in</span> module.declarations <span class="py-keyword">if</span> isinstance(c, ASG.Module)]</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">      self.module_queue.extend(children)</span>
<a id="line109"></a><span class="lineno">109</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:13 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
